;Start address for 16K machine code 32335
        ORG 32335
;Subroutine to find variables
FIND  : LD HL, (23627)           ; 32335 42  75  92
START : LD A, (23728)            ; 32338 58  176 92
        CP (HL)                  ; 32341 190
        RET Z                    ; 32342 200
        BIT 5, (HL)              ; 32343 203 110
        JR NZ, NEXT              ; 32345 32  8
        INC HL                   ; 32347 35
        LD E, (HL)               ; 32348 94
        INC HL                   ; 32349 35
        LD D, (HL)               ; 32350 86
        ADD HL, DE               ; 32351 25
        INC HL                   ; 32352 35
        JR START                 ; 32353 24  239
NEXT  : BIT 6, (HL)              ; 32355 203 118
        JR NZ, NEXT1             ; 32357 32  12
LOOP5 : INC HL                   ; 32359 35
        LD A, (HL)               ; 32360 126
        BIT 7, A                 ; 32361 203 127
        JR Z, LOOP5              ; 32363 40  250
LOOP6 : LD DE, 6                 ; 32365 17  6   0
        ADD HL, DE               ; 32368 25
        JR START                 ; 32369 24  223
NEXT1 : BIT 7, (HL)              ; 32371 203 126
        JR Z, LOOP6              ; 32373 40  246
        LD DE, 19                ; 32375 17  19  0
        ADD HL, DE               ; 32378 25
        JR START                 ; 32379 24  213

;Subroutine to set parameters of variable to be found
SETUP : LD (23728), A            ; 32381 50  176 92
        CALL FIND                ; 32384 205 79  126
        INC HL                   ; 32387 35
        INC HL                   ; 32388 35
        INC HL                   ; 32389 35
        LD A, (HL)               ; 32390 126
        LD (BC), A               ; 32391 2
        RET                      ; 32392 201

;Start of machine code routine
RUN   : LD BC, 23296             ; 32393 1   0   91
        LD A, 120                ; 32396 62  120
        CALL SETUP               ; 32398 205 125 126
        INC BC                   ; 32401 3
        LD A, 121                ; 32402 62  121
        CALL SETUP               ; 32404 205 125 126
        INC BC                   ; 32407 3
        LD A, 104                ; 32408 62  104
        CALL SETUP               ; 32410 205 125 126
        INC BC                   ; 32413 3
        LD A, 119                ; 32414 62  119
        CALL SETUP               ; 32416 205 125 126
        LD A, 65                 ; 32419 62  65
        LD (23728), A            ; 32421 50  176 92
        CALL FIND                ; 32424 205 79  126
        INC HL                   ; 32427 35
        LD E, (HL)               ; 32428 94
        INC HL                   ; 32429 35
        LD D, (HL)               ; 32430 86
        LD (23300), DE           ; 32431 237 83  4   91
        PUSH DE                  ; 32435 213
        POP BC                   ; 32436 193
        INC HL                   ; 32437 35
        LD DE, 23301             ; 32438 17  5   91
        LDIR                     ; 32441 237 176
        LD HL, (23296)           ; 32443 42  0   91
        XOR A                    ; 32446 175
        LD A, H                  ; 32447 124
        SBC A, 176               ; 32448 222 176
        JR C, YES                ; 32450 56  4
        LD H, A                  ; 32452 103
        LD (23296), HL           ; 32453 34  0   91
YES   : LD (23728), HL           ; 32456 34  176 92
        LD HL, 23301             ; 32459 33  5   91
RUN1  : PUSH HL                  ; 32462 229
        LD A, (HL)               ; 32463 126
        LD H, 0                  ; 32464 38  0
        LD L, A                  ; 32466 111
        ADD HL, HL               ; 32467 41
        ADD HL, HL               ; 32468 41
        ADD HL, HL               ; 32469 41
        LD DE, 15360             ; 32470 17  0   60
        ADD HL, DE               ; 32473 25
        LD B, 8                  ; 32474 6   8
LOOP4 : PUSH BC                  ; 32476 197
        LD BC, (23297)           ; 32477 237 75  1   91
LOOP3 : LD A, (HL)               ; 32481 126
        PUSH HL                  ; 32482 229
        PUSH BC                  ; 32483 197
        LD B, 8                  ; 32484 6   8
LOOP2 : PUSH BC                  ; 32486 197
        RLA                      ; 32487 23
        PUSH AF                  ; 32488 245
        JP C, PLOT               ; 32489 218 249 126
        LD HL, (23299)           ; 32492 42  3   91
        LD A, (23728)            ; 32495 58  176 92
        ADD A, L                 ; 32498 133
        LD (23728), A            ; 32499 50  176 92
        JP END                   ; 32502 195 15  127
PLOT  : LD BC, (23298)           ; 32505 237 75  2   91
LOOP1 : PUSH BC                  ; 32509 197
        LD BC, (23728)           ; 32510 237 75  176 92
        PUSH BC                  ; 32514 197
        CALL 22E5h,PLOT-SUB      ; 32515 205 229 34
        POP BC                   ; 32518 193
        INC C                    ; 32519 12
        LD (23728), BC           ; 32520 237 67  176 92
        POP BC                   ; 32524 193
        DJNZ LOOP1               ; 32525 16  238
END   : POP AF                   ; 32527 241
        POP BC                   ; 32528 193
        DJNZ LOOP2               ; 32529 16  211
        LD A, (23296)            ; 32531 58  0   91
        LD HL, 23728             ; 32534 33  176 92
        LD (HL), A               ; 32537 119
        INC HL                   ; 32538 35
        XOR A                    ; 32539 175
        LD A, (HL)               ; 32540 126
        SBC A, 176               ; 32541 222 176
        JR C, OK                 ; 32543 56  3
        LD (HL), A               ; 32545 119
        JR CONT                  ; 32546 24  8
OK    : LD A, (HL)               ; 32548 126
        CP 0                     ; 32549 254 0
        JR NZ, OK1               ; 32551 32  2
        LD (HL), 176             ; 32553 54  176
OK1   : DEC (HL)                 ; 32555 53
CONT  : POP BC                   ; 32556 193
        POP HL                   ; 32557 225
        DJNZ LOOP3               ; 32558 16  177
        INC HL                   ; 32560 35
        POP BC                   ; 32561 193
        DJNZ LOOP4               ; 32562 16  168
        LD A, (23299)            ; 32564 58  3   91
        ADD A, A                 ; 32567 135
        ADD A, A                 ; 32568 135
        ADD A, A                 ; 32569 135
        LD L, A                  ; 32570 111
        LD A, (23728)            ; 32571 58  176 92
        ADD A, L                 ; 32574 133
        LD (23296), A            ; 32575 50  0   91
        LD (23728), A            ; 32578 50  176 92
        LD A, (23297)            ; 32581 58  1   91
        LD (23729), A            ; 32584 50  177 92
        POP HL                   ; 32587 225
        INC HL                   ; 32588 35
        LD A, (23300)            ; 32589 58  4   91
        DEC A                    ; 32592 61
        RET Z                    ; 32593 200
        LD (23300), A            ; 32594 50  4   91
        JP RUN1                  ; 32597 195 206 12
        END
